Sliding Window Maximum | Leetcode

  Рет қаралды 263,143

take U forward

take U forward

Күн бұрын

Пікірлер: 224
@takeUforward
@takeUforward 3 жыл бұрын
If you understand it, please do like it, and if possible please spare 2 seconds for a comment :)
@anoopraj9319
@anoopraj9319 3 жыл бұрын
make videos on dp please
@JohnWick-kh7ow
@JohnWick-kh7ow 3 жыл бұрын
What's the difference between deque and list?
@PrinceKumar-el7ob
@PrinceKumar-el7ob 3 жыл бұрын
16:22 smaller than equal to is not ok!! only smaller than will be ok striver. i don't know why anyone didn't point this out.
@pranayjain._
@pranayjain._ Жыл бұрын
@@PrinceKumar-el7ob It would work. Try some test cases.
@artofwrick
@artofwrick 9 ай бұрын
The best explanation on sliding window
@harigs72
@harigs72 14 күн бұрын
I did it by myself.i have been following one coding sheet where i have solved all queue problems (expect one problem and i was able to come up with optimal solution)by myself include one cache problem (Degin pattern)as well .i solve sliding window problem i have cross 4 problem and i have solved 4 problem bu myself.including this one ..i have learnt alot from you ..your teaching style is literally nice . thankyou for work ...🎉❤ Keep doing In the problem what i did was 10:36 instead of checking from back first check peek If peek
@priyanshityagi8313
@priyanshityagi8313 2 жыл бұрын
This explanation literally made me overcome my fear of stacks and queues. Thank you so much!
@ayushrawat7951
@ayushrawat7951 2 жыл бұрын
Ya exactly..... I also have fear of stack and queue.. Even though they are quite easy to understand.
@purushottam108
@purushottam108 5 ай бұрын
How one question can over come your fear? 🤔🤔🤔🤔
@alammahtab08
@alammahtab08 Ай бұрын
Sliding Window Approach with Monotonic Queue The idea is to keep the maximum number in the sliding window at the front of the Deque and the possible maximum numbers at the rear end (last) of the queue. The Deque would have numbers sorted in descending order, front having the maximum number and rear would have the smallest in the current window. As we iterate over the array if num[i] is greater than the smallest number of current window than we start removing the numbers as long as num[i] is greater than number in the window. Also we add the index of current number in Deque as this number could be possible maximum as the window slides to the right. We could have tried to use Stack or PriorityQueue to keep track of maximum in the current window, but we don't only need to track maximum number in the current window but also other numbers (possible maximum) which are less than maximum number in the current window. Because as we move to the next window, these possible maximum numbers might become the maximum number in that window. Choosing the right Data Structure : Double Ended Queue (Deque) If we use Stack, we can only get access to the top element, for accessing other elements we would have to pop the elements from the stack and would have to push it back to stack. Similarly if we use PriorityQueue we can only get access to the min or max element which is at the top of heap, for accessing other elements we would have to remove elements from the heap and would have to push it back to heap. A Double ended Queue allows us to perform operation on both the ends of the data structure and we can easily access the elements in Deque. We could have used Doubly Linked List as well but the problem is, it lacks the ease of access to perform operation or access elements from both the front and rear end. In Java Deque gives us methods e.g. addFirst(), addLast(), removeFirst(), removeLast(), peekFirst(), peekLast() to easily access the front/rear element and also start traversal from the front or rear. Important Points : We store the index i in Deque and not num[i], this is because we also have to remove numbers from the Deque as window slides to the right. We can check if index is out of current window we remove the number. For given window of K, remember we don't try to store k elements in the Deque, rather we just need to keep the maximum number at the front of Deque and add the current number at the rear end of Deque. And when we remove element from Deque we start from the rear end of Deque.
@zetro6311
@zetro6311 2 жыл бұрын
I got this question in a Microsoft interview for SDE 1
@kingmaker9082
@kingmaker9082 2 жыл бұрын
Is it offcampus or oncampus
@zetro6311
@zetro6311 2 жыл бұрын
@@kingmaker9082 Off campus
@kingmaker9082
@kingmaker9082 2 жыл бұрын
@@zetro6311 from where u applied for Microsoft or have u got any referral? Plz guide me...btw what is the result of interview bro?
@vinyass3733
@vinyass3733 2 жыл бұрын
@@kingmaker9082 hello bro? which batch are you?
@kingmaker9082
@kingmaker9082 2 жыл бұрын
@@vinyass3733 23 batch
@parthsalat
@parthsalat 2 жыл бұрын
I couldn't understand this problem's solution even after reading several leetcode discuss posts. However, I understood this completely at once after watching your video! Thanks!
@harshexploring4922
@harshexploring4922 2 жыл бұрын
kudos to your patience while explaining sir.The way of you instruct the solution to the problem was quite appealing, unlike some other youtubers who just write the code in rush without explaining properly. Thanks again
@coolmishrag8622
@coolmishrag8622 8 ай бұрын
bro getting harsh with apna collegeg
@spardha-yug
@spardha-yug 2 жыл бұрын
THank you bro. Brute force+Optimized+code explanation---->complete video. Thanks a ton.
@koushalsharma7041
@koushalsharma7041 2 жыл бұрын
It is always challenging as well as fun to learn the optimal solution. But, your explanation helps a lot to understand it better.
@shashank_0807
@shashank_0807 3 ай бұрын
Much better explanation than in the new playlist !
@patelchintu6492
@patelchintu6492 3 жыл бұрын
Waiting for tree series :)
@AbhishekKumar-hh8xc
@AbhishekKumar-hh8xc 2 жыл бұрын
Good explanation. That's an art which is rare. Every one knows the steps and code and solution, But very few know the explanation and intution
@nayan_CSE
@nayan_CSE Жыл бұрын
What a explanation 😯...I think this is the best video of window problem in KZbin... Thank you so much for this great video....
@deepikasrivastava3040
@deepikasrivastava3040 3 жыл бұрын
Best Explanation. Thank you so much. Finally understood the use of deque for this problem.
@thatbadguy2899
@thatbadguy2899 3 жыл бұрын
Please increase the frequency of uploads as this is PLACEMENT SEASON
@AlokKumar-or8jz
@AlokKumar-or8jz Жыл бұрын
easiest solution by naiveApproach vector maxSlidingWindow(vector arr,int k){//TLE vector ans; int n= arr.size(); for (int i = 0; i < n-k+1; i++) { ans.push_back(*max_element(arr.begin()+i,arr.begin()+i+k)); // T.C = O(n) max_element } return ans; }
@pb_yt992
@pb_yt992 3 жыл бұрын
Such a Nice Explanation even a beginner can understand. Thanks a lot
@rajeshg3570
@rajeshg3570 2 жыл бұрын
Can't find a better explanation than this for a hard problem.. simple love it
@juanceja899
@juanceja899 2 жыл бұрын
I just had an interview with Google today and this was the algorithm I was given. That's why I'm here Haha. I was able to do it, but I took a different approach.
@raghav5354
@raghav5354 Жыл бұрын
I don’t get the intuition that whenever we remove leftmost index from our window to go to the next window, why the left most index will also be the left most element in the deque (so we just remove the first element from our deque). In my thinking, I should loop through the deque to find the index to remove for every window.
@pratikroy710
@pratikroy710 27 күн бұрын
The deque always contains elements in non-increasing order. In other words, deque head always be the greatest element of the window. Thus, when we from move from window [i, i+k-1] to [i+1, i+k], we only need to check if arr[i] (element getting ejected from the window) is at the head or not. It will always be at head if it is present in the deque while it is being ejected. Think like this, if there is an element at index j in the window [i, i+k-1] where arr[j]>arr[i], then while inserting j in the deque i would have been removed. Thus if index i is being ejected, then i could only present in the deque only at head.
@aryanchauhan8066
@aryanchauhan8066 3 жыл бұрын
Very good explaination , though i have to see it 2 times to completely understand the concept👍
@rishurana9655
@rishurana9655 2 жыл бұрын
This question can also be solve using heap
@manask8116
@manask8116 Жыл бұрын
you can do by using a multiset as well , it takes nlogn but its very simple to write the code
@stith_pragya
@stith_pragya 7 ай бұрын
UNDERSTOOD..........Thank You So Much for this wonderful video...........🙏🏻🙏🏻🙏🏻🙏🏻🙏🏻🙏🏻
@aadityaupadhyay6264
@aadityaupadhyay6264 3 жыл бұрын
That definitely not at 5:15 reminds me of Dhoni xD.
@earninghere7442
@earninghere7442 4 ай бұрын
Python simple one x=[1,3,-1,-3,5,3,6,7] k=3 y=[] for i in range(len(x)-2): y.append(max(x[i:i+k])) print(y)
@sushantchoudhary444
@sushantchoudhary444 Жыл бұрын
you are amazing God bless you. I wanna become like you one day
@aryanchauhan8897
@aryanchauhan8897 3 жыл бұрын
Very great explanation. Thank you bhaiya for helping out the students but I have one suggestion pls upload videos on regular basis. I know u are very busy but it will be helpful for students who are appearing in this placement season. We have found the solution of dse sheet from anywhere but the video explanation of yours is very helpful to remember the concepts and do similar type questions on particular algorithms.
@AyushGupta-kp9xf
@AyushGupta-kp9xf 3 жыл бұрын
Thanks man I was doubtful about the On complexity. your explanation cleared it :)
@Satya-g5t
@Satya-g5t 2 ай бұрын
good explanation, thank you.
@lifegood6401
@lifegood6401 3 жыл бұрын
Waiting for tree series eagerly. Placement already started in college, and tree , dp, strings remaining from the sheet
@neerajgarg9096
@neerajgarg9096 2 жыл бұрын
*Brute force* class Solution { public: vector maxSlidingWindow(vector& nums, int k) { vectorans; int n = nums.size(); for(int i=0; i
@abhishekkmandal
@abhishekkmandal 3 жыл бұрын
at 3:48 , deque should be Double ended queues I guess and not doubly linked list , btw nice explanation :)
@alokesh985
@alokesh985 3 жыл бұрын
I think he meant that double-ended queues are typically implemented using doubly linked lists
@harshexploring4922
@harshexploring4922 2 жыл бұрын
@@alokesh985 if i am not wrong in doubly linked list one can access,insert and pop elements at any position but in deque one can do it only at front and back
@iamnoob7593
@iamnoob7593 Жыл бұрын
Understood Thanks Striver , I am suffering from health issues , Still not giving up.
@HARSHAVARDHANE-r1g
@HARSHAVARDHANE-r1g 10 ай бұрын
the flow of teaching is amazing bor
@Luk3Stein
@Luk3Stein Жыл бұрын
Godly explanation. Suddenly, this problem does not look Leetcode Hard level
@shalinig1253
@shalinig1253 3 ай бұрын
Great Explanation!
@jaydalsaniya6986
@jaydalsaniya6986 2 жыл бұрын
Worst case occurs when k = 1 , Inserting all N element and N-1 elements will be removed. This is because for each array element two operation DELETION -> INSERTION IS PERFORMED .
@kapilpatel9379
@kapilpatel9379 2 жыл бұрын
Could not understand completely, but will come back
@anandyadav_
@anandyadav_ 3 жыл бұрын
I just like every video of yours becuz your's are really gona help.
@sohailshaik9
@sohailshaik9 2 жыл бұрын
had to watch 2 times to understand this but it was beautiful. thanks
@kotapatiswaraj06
@kotapatiswaraj06 Жыл бұрын
Great Explanation ! Thanks for the free quality content
@1qwertyuiop1000
@1qwertyuiop1000 Жыл бұрын
How about using Max Heap with size K.. time complexity will be NLogN i guess.. Space complexity will be O(K)
@ujjawaldewangan8345
@ujjawaldewangan8345 3 жыл бұрын
It is necessary because no one teach us like you
@helderfilho4724
@helderfilho4724 Жыл бұрын
Thank You very much! You explain very well.
@_dion_
@_dion_ 10 ай бұрын
the best explanation on yt.
@khumukchamsonam4471
@khumukchamsonam4471 3 жыл бұрын
great explaination as always.... waiting for more videos
@afaqueahmad7117
@afaqueahmad7117 Жыл бұрын
Such an easy explanation, you make it look simple, love it!
@bharatmehta30
@bharatmehta30 2 жыл бұрын
dude!! your explanation is amazing.
@anirudhvermarr
@anirudhvermarr 8 ай бұрын
Simply, thank you!
@hussainkanchwala968
@hussainkanchwala968 9 ай бұрын
very clear explanation, thanks
@vaalarivan_p
@vaalarivan_p Жыл бұрын
3:20 - 6:25
@sujalgupta6100
@sujalgupta6100 2 жыл бұрын
this was very hard for me . thanks for such a good explanation.
@oqant0424
@oqant0424 2 жыл бұрын
what an Explanation...........hats off ✌✌
@shubham7668
@shubham7668 2 жыл бұрын
Respect for Aditya verma increased after this lecture 🙇‍♀️🙇‍♀️ I thought Raj Bhaiya would break the record of his explanation, but he is still unbeatable.
@vagabondfoodie5788
@vagabondfoodie5788 Жыл бұрын
Yes I can't agree more 😤😤🔥🔥
@yashsaini9494
@yashsaini9494 2 жыл бұрын
This person is gifted
@rishabhyadav4994
@rishabhyadav4994 3 жыл бұрын
This can also be solved using multiset, can we use multiset in the interview bhaiya?
@vuyyurishanmukhaabhinavvar4096
@vuyyurishanmukhaabhinavvar4096 3 жыл бұрын
Bhai when your course starts in unacademy pls update waiting for your course
@freshcontent3729
@freshcontent3729 3 жыл бұрын
bhaiya please bring more videos fast fast .. placements are starting!!
@prachigupta9713
@prachigupta9713 2 жыл бұрын
Thankyou So much for such excellent explaination
@gandhijainamgunvantkumar6783
@gandhijainamgunvantkumar6783 2 жыл бұрын
Bhaiya please make a video on the question: Find maximum of minimum for all the window sizes.
@_-6912
@_-6912 3 жыл бұрын
I understood the solution!
@itz_me_imraan02
@itz_me_imraan02 Жыл бұрын
I solved it using segment tree
@poorvaparande5933
@poorvaparande5933 2 жыл бұрын
Thanks a lot! this was super helpful :)
@StudyEmail-p9u
@StudyEmail-p9u 10 ай бұрын
Thank You!!
@ketanahuja8939
@ketanahuja8939 3 жыл бұрын
Great Explanation
@paragroy5359
@paragroy5359 2 жыл бұрын
Nice explanation your videos are really good...please keep on making such videos...you are doing a great job.
@rohankumar393
@rohankumar393 3 жыл бұрын
Please add heap questions in SDE sheet.
@shristisrivastava7054
@shristisrivastava7054 Жыл бұрын
Huge fan of your videos
@kidvschild7240
@kidvschild7240 2 жыл бұрын
Great brother 👌👌 keep it up 👆
@KittyInCali
@KittyInCali 3 ай бұрын
thanks for great explanation
@nani4027
@nani4027 3 жыл бұрын
Nice explanation bro!
@mugambo5505
@mugambo5505 2 жыл бұрын
awesome explanation bro. all doubts gone
@s41nt2
@s41nt2 Жыл бұрын
Genius guy🙌🙌
@cinime
@cinime Жыл бұрын
Understood! Amazing explanation as always, thank you very much!!
@millionaires1
@millionaires1 2 жыл бұрын
Very good explanation, thank you bro
@sudiksha586
@sudiksha586 Жыл бұрын
thank you striver!
@nikhilrana2680
@nikhilrana2680 3 жыл бұрын
Bhaiya...shukr h..aap aaye yahan...😅😂bda acha lga....
@takeUforward
@takeUforward 3 жыл бұрын
Haan bhai, Insta follow karoge toh pata hoga na 😴
@nikhilrana2680
@nikhilrana2680 3 жыл бұрын
Bhaiya krta hu apko follow but...2-3 din se insta nhi chalaya😂😅
@nikhilrana2680
@nikhilrana2680 3 жыл бұрын
Bhaiya ek cheex aur, voh apki trees ki series kb tk ayegi...mein 1 year mein hu..dsa shuru kr dia h...trees padna h aapse, plzz bhaiya jldi lao....😄🥰
@171-supratiksantra5
@171-supratiksantra5 3 жыл бұрын
I got this question in one interview round and also in the written round
@shalabhbhatiya2292
@shalabhbhatiya2292 3 жыл бұрын
bhai tumhari video inti badiya hai to course laine ki jarurat hi nhi h
@subhankarkanrar9494
@subhankarkanrar9494 4 ай бұрын
Love❤😊
@naveengarg7435
@naveengarg7435 2 жыл бұрын
directly jumped to solution, Intution is missing... :(
@parthh1112
@parthh1112 9 ай бұрын
class Solution { public: vector maxSlidingWindow(vector&v, int k) { vector ans; int i,j;i=j=0; deque q; while((i < v.size()) && (ans.size() < v.size() - k + 1)){ while((j
@perumallayaswanth83
@perumallayaswanth83 3 жыл бұрын
Bro can u please make a video on how to deal with large numbers and what exactly 10^9+7.
@shreyashachoudhary480
@shreyashachoudhary480 2 жыл бұрын
Thanks!
@krishnavamsichinnapareddy
@krishnavamsichinnapareddy Жыл бұрын
Nice explanation 👍
@511sanjeevthalod7
@511sanjeevthalod7 3 жыл бұрын
Bro please make a video on your jee journey
@ankoor
@ankoor 3 жыл бұрын
It can also be solved using Stack by finding Next Greater to Right: vector maxSlidingWindow(vector& nums, int k) { int n = nums.size(); stack stk; stk.push(n-1); vector ngr(n, 0); ngr[n-1] = INT_MAX; for (auto i=n-2; i>=0; i--){ while (! stk.empty() && nums[stk.top()]
@nikhilpatro5905
@nikhilpatro5905 3 жыл бұрын
I think you also have to add case when nge[j] == INT_MAX then break out of the while loop and set max element of that window as nums[j]
@RAHULROY-sb9nt
@RAHULROY-sb9nt Жыл бұрын
videos are priceless.
@shobhitmishra739
@shobhitmishra739 3 жыл бұрын
can we use max heap??
@1murkeybadmayn
@1murkeybadmayn Жыл бұрын
The part that confuses me is dq.empty() or dq.front(), i thought they return a value at the index not the index itself. So how is it used here that it is checking the index and not the value? I am so confused.
@asp1859
@asp1859 Жыл бұрын
Is the time complexity , really O(n) here ??.... because, if we take example, 6,4,5,3,2 with window size k =3, then once the greatest element 6 is removed, the next greatest element that is 5 should be placed at top, and for doing that worst case, there will be (k-1) comparisons. Anybody please correct me if I am wrong .
@RamKrishna-ou6li
@RamKrishna-ou6li 3 жыл бұрын
good explanation thank you so much
@rishabhbatra3022
@rishabhbatra3022 3 жыл бұрын
Bhaiya Tree series kb ari h ek br date bta do pls...
@takeUforward
@takeUforward 3 жыл бұрын
100k pe. Ye me 100 wi baar bol raha 😵‍💫😂
@biswaranjanbarik4052
@biswaranjanbarik4052 2 жыл бұрын
Ur explanation is so awesome.. It's really helpful to us..🙏 can you plzz upload the video of 862. Leeetcode problem Shortest Subarray with Sum at Least K.🙏🙏 please sir please I'm really stuck in this prblm.
@kritikajain6677
@kritikajain6677 2 жыл бұрын
Great explanation!
@anutoshghosh7893
@anutoshghosh7893 9 ай бұрын
Is there any algorithm related to next greatest element or next smallest element, like how to devise algorithms for these type of problems, how to know we need a deque in this case as we do operations on both sides here?
@ManishKumar-qx1kh
@ManishKumar-qx1kh Ай бұрын
There's another solution of this using next greater element approach, saw it here kzbin.info/www/bejne/qnS5gISOaNGKm6s as i was also thinking of applying nge algorithm.
@smfk049
@smfk049 2 жыл бұрын
nice explanation
@rushikeshdeshmukhmarathibo7465
@rushikeshdeshmukhmarathibo7465 Жыл бұрын
Understood bhaiya ❤
@theresilientpianist7114
@theresilientpianist7114 11 ай бұрын
❣❣you are a legend🙏🙏
Rotten Oranges (BFS) | C++ & Java Code |G-10. Rotten Oranges
26:52
take U forward
Рет қаралды 60 М.
Sliding Window Maximum - Monotonic Queue - Leetcode 239
15:46
NeetCode
Рет қаралды 264 М.
Чистка воды совком от денег
00:32
FD Vasya
Рет қаралды 2,4 МЛН
Why no RONALDO?! 🤔⚽️
00:28
Celine Dept
Рет қаралды 84 МЛН
L16. Sliding Window Maximum | Stack and Queue Playlist
19:58
take U forward
Рет қаралды 31 М.
Kadane's Algorithm | Maximum Subarray Sum | Finding and Printing
20:09
take U forward
Рет қаралды 491 М.
How to Solve ANY LeetCode Problem (Step-by-Step)
12:37
Codebagel
Рет қаралды 303 М.
Maximum Sum Subarray of size K | Sliding Window
23:42
Aditya Verma
Рет қаралды 333 М.
I Solved 100 LeetCode Problems
13:11
Green Code
Рет қаралды 253 М.
239. Sliding Window Maximum II Monotonic Deque II Leetcode 239
21:15
Sliding Window Technique - Algorithmic Mental Models
36:45
Ryan Schachte
Рет қаралды 363 М.
Why I like C programming more than Web Dev (rant)
3:57
NeetCodeIO
Рет қаралды 184 М.